#!/usr/bin/php
<?php

/* Version 1.0 written by Ierlandfan */
/* Version 1.0 modified by DennisD */
/* Version 2.0 rewritten by FunFair */
/* Version 3.0 update by FunFair */
/* Version 3.1 update by FunFair */
/* 12-03-2018 */

/*
        Changelog Version 3.1
        - Readded the comparisment with Domoticz DB. When Toon disconnects from Wifi it is still possible wrong values will be written.

	Changelog Version 3.0
        - Updated the script to use RRD (thanks to user glsf91).
        - Removed comparisment with Domoticz DB. Not necessary anymore since de RRD doesn't zero the values.

	Changelog Version 2.2:
	- Corrected Low and Normal tariff. They were reversed.
	
	Changelog Version 2.1
	- Removed the compare to previous value, so it will update every minute.

	Changelog Version 2.0:																		
	- Rewrite from version 1.0																	
	- Define IP adresses and idx value at start													
	- Check if Toon value is lower than Domoticz Value. (In case connection is lost with meteradapter, Toon will output wrong values) 
	*/

/* Instructions:
	- Place script in Domoticz folder /home/pi/domoticz/scripts/p1_meter/ or desired folder.
	- Make sure Curl is installed (sudo apt-get install php-curl).
	- Make sure script is executable (chmod +x filename.php).
	- All #echo's are used for debugging.
	- Put script in 'crontab -e' to run every minute. */ 
	  #Example crontab: (*/1 * * * * /home/pi/domoticz/scripts/p1_meter/electricity_data_json.php)
		
/* Set IP addresses and idx*/
$IPDomoticz = '192.168.0.200:8080';
$IPToon = '192.168.0.11';
$idx = 25;

/* Get current date */
$datum =  date("d-m-Y");
echo "Request for FROM date: " . $datum . "\n";
echo "Now: ". date("Y-m-d H:i:s") . "\n";

/* read electricity counter from Domoticz */
$json_string = file_get_contents("http://$IPDomoticz/json.htm?type=devices&rid=$idx");
$parsed_json = json_decode($json_string, true);
$parsed_json = $parsed_json['result'][0];
$ElecCounterDomoticz = $parsed_json['Data']*1000;
echo "Electricity Counter Domoticz = ";
echo $ElecCounterDomoticz;
echo " Wh";
echo "\n";

/* Get Electricity usage counter LT from Toon */
$file_string_electLT = file_get_contents("http://$IPToon/hcb_rrd?action=getRrdData&loggerName=elec_quantity_lt&rra=5yrhours&readableTime=1&nullForNaN=1&from=$datum" );
$parsed_json = json_decode($file_string_electLT, true);

if ( empty($parsed_json)) {
        echo "Array is empty. Stop executing\n";
        return;
}

/* Get last value of array */
$keys = array_keys($parsed_json);
end($parsed_json);
$key = key($parsed_json);
$ElecUsageCounterLT = $parsed_json[$key];
echo "Electricity LT counter from Toon = " . $ElecUsageCounterLT . " Wh" . "\n";

/* Get Electricity usage counter NT from Toon */
$file_string_electNT = file_get_contents("http://$IPToon/hcb_rrd?action=getRrdData&loggerName=elec_quantity_nt&rra=5yrhours&readableTime=1&nullForNaN=1&from=$datum" );
$parsed_json = json_decode($file_string_electNT, true);
if ( empty($parsed_json)) {
        echo "Array is empty. Stop executing\n";
        return;
}

/* Get last value of array */
$keys = array_keys($parsed_json);
end($parsed_json);
$key = key($parsed_json);
$ElecUsageCounterNT = $parsed_json[$key];
echo "Electricity NT counter from Toon = " . $ElecUsageCounterNT . " Wh" . "\n";

/* extract counter normal tariff and low tariff and add them together */
$ElecCounterToonTotal = ($ElecUsageCounterLT + $ElecUsageCounterNT);
echo "Electricity Counter Toon = " . $ElecCounterToonTotal . " Wh" . "\n";

/* start of current Energy Usage import */
$file_string_ElecUsage = file_get_contents("http://$IPToon/happ_pwrusage?action=GetCurrentUsage");
$parsed_json_ElecUsage = json_decode($file_string_ElecUsage, true);

/* extract the current powerusage */
$ElecUsageToon=$parsed_json_ElecUsage['powerUsage']['value'];
echo "Electricity Usage Toon = " . $ElecUsageToon . " Watt" . "\n";

/* write new value to Domoticz */
if ($ElecCounterDomoticz == 0){ #this is for the first run only, when the idx is still empty.
        $WriteInitValue = curl_init("http://$IPDomoticz/json.htm?type=command&param=udevice&idx=$idx&nvalue=0&svalue=$ElecUsageToon;$ElecCounterToonTotal");
        curl_exec($WriteInitValue);
        }
        else if ($ElecCounterToonTotal < $ElecCounterDomoticz){
                echo "Toon value incorrect, do nothing \n";
        }
        else if ($ElecCounterToonTotal >= $ElecCounterDomoticz){
                $WriteValue = curl_init("http://$IPDomoticz/json.htm?type=command&param=udevice&idx=$idx&nvalue=0&svalue=$ElecUsageToon;$ElecCounterToonTotal");
                echo "\n";
                echo "Write new value \n";
                curl_exec($WriteValue);
        }
        else {
                echo "Domoticz value incorrect, do nothing \n";
        }
?>
