#!/usr/bin/php
<?php

/* Version 1.0 written by Ierlandfan */
/* Version 1.0 modified by DennisD */
/* Version 2.0 rewritten by FunFair */
/* Version 3.0 update by FunFair */
/* Version 3.1 update by FunFair */
/* 12-03-2018 */

/* 
	Changelog Version 3.1
	- Readded the comparisment with Domoticz DB. When Toon disconnects from Wifi it is still possible wrong values will be written.

	Changelog Version 3.0
	- Updated the script to use RRD (thanks to user glsf91).
	- Removed comparisment with Domoticz DB. Not necessary anymore since de RRD doesn't zero the values.

	Changelog Version 2.1
	- Removed the compare to previous value, so it will update every minute.

	Changelog Version 2.0:																		
	- Rewrite from version 1.0																	
	- Define IP adresses and idx value at start													
	- Check if Toon value is higher than Domoticz Value. (In case connection is lost with meteradapter, Toon will output wrong values) 
*/

/* Instructions:
	- Place script in Domoticz folder /home/pi/domoticz/scripts/p1_meter/ or desired folder.
	- Make sure Curl is installed (sudo apt-get install php-curl).
	- Make sure script is executable (chmod +x filename.php).
	- All echo's are used for debugging.
	- Put script in 'crontab -e' to run every minute. */ 
	  #Example crontab: (*/1 * * * * /home/pi/domoticz/scripts/p1_meter/gas_data_json.php)
	
		
/* Set IP addresses and idx*/
$IPDomoticz = '192.168.0.200:8080'; #use 'username:password@domoticz-ip:port' in case of password protection.
$IPToon = '192.168.0.11';
$idx = 24;

/* Get current date */
$datum =  date("d-m-Y");
echo "Request for FROM date: " . $datum . "\n";
echo "Now: ". date("Y-m-d H:i:s") . "\n";

/* read Gasmeter counter from Domoticz */
$json_string = file_get_contents("http://$IPDomoticz/json.htm?type=devices&rid=$idx");
$parsed_json = json_decode($json_string, true);
$parsed_json = $parsed_json['result'][0];
$GasCounterDomoticz = $parsed_json['Counter']*1000; #value Domoticz is in m3, convert to liter$
echo "Gas Value Domoticz = " . $GasCounterDomoticz . " liters" . "\n";

/* Get Gas counter from Toon */
$file_string_gas = file_get_contents("http://$IPToon/hcb_rrd?action=getRrdData&loggerName=gas_quantity&rra=5yrhours&readableTime=1&nullForNaN=1&from=$datum" );
$parsed_json = json_decode($file_string_gas, true);

if ( empty($parsed_json)) {
        echo "Array is empty. Stop executing\n";
        return;
}

/* Get last value of array */
$keys = array_keys($parsed_json);
end($parsed_json);
$key = key($parsed_json);
$GasCounterToon = $parsed_json[$key];
echo "Gas counter from Toon = " . $GasCounterToon. " Liters";
echo "\n";


/* write new value to Domoticz */
if ($GasCounterDomoticz == 0){ #this is for the first run only, when the idx is still empty.
        $WriteInitValue = curl_init("http://$IPDomoticz/json.htm?type=command&param=udevice&idx=$idx&nvalue=0&svalue=$GasCounterToon");
        curl_exec($WriteInitValue);
        }
        else if ($GasCounterToon > $GasCounterDomoticz+1000){ #1000 liters in 1 hour difference is an unrealistic increase.
                echo "Toon value incorrect, do nothing \n";
        }
        else if ($GasCounterToon >= $GasCounterDomoticz){
                $WriteValue = curl_init("http://$IPDomoticz/json.htm?type=command&param=udevice&idx=$idx&nvalue=0&svalue=$GasCounterToon");
                echo "\n";
                echo "Write new value \n";
                curl_exec($WriteValue);
        }
        else {
                echo "Domoticz value incorrect, do nothing \n";
        }
?>
