#!/usr/bin/php
<?php

error_reporting(E_ALL);

/* Version 1.0 written by Ierlandfan */
/* Version 1.0 modified by DennisD */
/* Version 2.0 rewritten by FunFair */
/* Version 2.1 update by FunFair */
/* Version 3.0 modified by glsf91 for using RRD */
/* Version 3.1 update by FunFair */
/* Version 3.2 update by FunFair */
/* 12-03-2018 */

/*
        Changelog Version 3.2
        - Readded the comparisment with Domoticz DB. When Toon disconnects from Wifi it is still possible wrong values will be written.

	Changelog Version 3.1
	- Updated the P1 Smart meter script to use RRD.
	- Removed comparisment with Domoticz DB. Not necessary anymore since de RRD doesn't zero the values.

	Changelog Version 2.2:
	- Corrected Low and Normal tariff. They were reversed.
	
	Changelog Version 2.1:																		
	- Implemented production counters for P1 meter.
	- Removed the compare to previous value, so it will update every minute.

	Changelog Version 2.0:																		
	- Rewrite from version 1.0																	
	- Define IP adresses and idx value at start													
	- Check if Toon value is lower than Domoticz Value. (In case connection is lost with meteradapter, Toon will output wrong values.) */

/* Instructions:
	- Create a virtual P1 meter in Domoticz and write down idx value.
	- Place script in Domoticz folder /home/pi/domoticz/scripts/p1_meter/ or desired folder.
	- Set IP numbers and idx values below.
	- Make sure Curl is installed (sudo apt-get install php-curl).
	- Make sure script is executable (chmod +x filename.php).
	- All echo's are used for debugging.
	- Put script in 'crontab -e' to run every minute. */ 
	  #Example crontab: (*/1 * * * * /home/pi/domoticz/scripts/p1_meter/p1_meter_data_json.php)
	
		
/* Set IP addresses and idx */
$IPDomoticz = '192.168.0.200:8080'; #use 'username:password@domoticz-ip:port' in case of password protection.
$IPToon = '192.168.0.11';
$idx = 26;

/* Get current date */
$datum =  date("d-m-Y");
echo "Request for FROM date: " . $datum . "\n";
echo "Now: ". date("Y-m-d H:i:s") . "\n";

/* read electricity counters from Domoticz */
$json_string = file_get_contents("http://$IPDomoticz/json.htm?type=devices&rid=$idx");
$parsed_json = json_decode($json_string, true);
$parsed_json = $parsed_json['result'][0];
$ElecUsageCounterDomoticz = $parsed_json['Counter']*1000;
$ElecProductionCounterDomoticz = $parsed_json['CounterDeliv']*1000;
echo "Electricity Usage Counter Domoticz = " . $ElecUsageCounterDomoticz . " Wh" . "\n";
echo "Electricity Production Counter Domoticz = " . $ElecProductionCounterDomoticz . " Wh" . "\n";
echo "\n";

/* start of current Energy Usage import */
$file_string_ElecUsage = file_get_contents("http://$IPToon/happ_pwrusage?action=GetCurrentUsage");
$parsed_json_ElecUsage = json_decode($file_string_ElecUsage, true);

/* start of current Energy Production import */
$file_string_ElecProduction = file_get_contents("http://$IPToon/happ_pwrusage?action=GetCurrentUsage");
$parsed_json_ElecProduction = json_decode($file_string_ElecProduction, true);

/* extract the current powerusage */
$ElecUsageToon=$parsed_json_ElecUsage['powerUsage']['value'];
echo "Electricity Usage Toon = " . $ElecUsageToon . " Watt" . "\n";

/* extract the current powerProduction */
$ElecProductionToon=$parsed_json_ElecProduction['powerProduction']['value'];
echo "Electricity Production Toon = " . $ElecProductionToon . " Watt" . "\n";

/* Get Electricity usage counter LT from Toon */
$file_string_electLT = file_get_contents("http://$IPToon/hcb_rrd?action=getRrdData&loggerName=elec_quantity_lt&rra=5yrhours&readableTime=1&nullForNaN=1&from=$datum" );
$parsed_json = json_decode($file_string_electLT, true);

if ( empty($parsed_json)) {
        echo "Array is empty. Stop executing\n";
        return;
}

/* Get last value of array */
$keys = array_keys($parsed_json);
end($parsed_json);
$key = key($parsed_json);
$ElecUsageCounterLT = $parsed_json[$key];
echo "Electricity LT counter from Toon = " . $ElecUsageCounterLT . " Wh" . "\n";

/* Get Electricity usage counter NT from Toon */
$file_string_electNT = file_get_contents("http://$IPToon/hcb_rrd?action=getRrdData&loggerName=elec_quantity_nt&rra=5yrhours&readableTime=1&nullForNaN=1&from=$datum" );
$parsed_json = json_decode($file_string_electNT, true);
if ( empty($parsed_json)) {
        echo "Array is empty. Stop executing\n";
        return;
}

/* Get last value of array */
$keys = array_keys($parsed_json);
end($parsed_json);
$key = key($parsed_json);
$ElecUsageCounterNT = $parsed_json[$key];
echo "Electricity NT counter from Toon = " . $ElecUsageCounterNT . " Wh";
echo "\n";

/* Add Electricity usage counters NT+LT */
$ElecUsageCounterToonTotal = ($ElecUsageCounterLT + $ElecUsageCounterNT);
echo "Electricity Counter Toon Total = " . $ElecUsageCounterToonTotal . " Wh" . "\n";

/* Get Electricity production counter LT from Toon */
$file_string_electLT = file_get_contents("http://$IPToon/hcb_rrd?action=getRrdData&loggerName=elec_quantity_lt_produ&rra=5yrhours&readableTime=1&nullForNaN=1&from=$datum" );
$parsed_json = json_decode($file_string_electLT, true);

if ( empty($parsed_json)) {
        echo "Array is empty. Stop executing\n";
        return;
}

/* Get last value of array */
$keys = array_keys($parsed_json);
end($parsed_json);
$key = key($parsed_json);
$ElecProductionCounterLT = $parsed_json[$key];
echo "Electricity production counter LT from Toon = " . $ElecProductionCounterLT . " Wh" . "\n";


/* Get Electricity production counter NT from Toon */
$file_string_electLT = file_get_contents("http://$IPToon/hcb_rrd?action=getRrdData&loggerName=elec_quantity_nt_produ&rra=5yrhours&readableTime=1&nullForNaN=1&from=$datum" );
$parsed_json = json_decode($file_string_electLT, true);

if ( empty($parsed_json)) {
        echo "Array is empty. Stop executing\n";
        return;
}

/* Get last value of array */
$keys = array_keys($parsed_json);
end($parsed_json);
$key = key($parsed_json);
$ElecProductionCounterNT = $parsed_json[$key];
echo "Electricity production counter NT from Toon = " . $ElecProductionCounterNT . " Wh" . "\n";


/* write new value to Domoticz  */
if ($ElecUsageCounterDomoticz == 0){ #this is for the first run only, when the idx is still empty.
        $WriteInitValue = curl_init("http://$IPDomoticz/json.htm?type=command&param=udevice&idx=$idx&nvalue=0&svalue=$ElecUsageCounterLT;$ElecUsageCounterNT;$ElecProductionCounterLT;$ElecProductionCounterNT;$ElecUsageToon;$ElecProductionToon;");

                curl_exec($WriteInitValue);
        }
        else if ($ElecUsageCounterToonTotal < $ElecUsageCounterDomoticz){
                echo "Toon value incorrect, do nothing \n";
        }
        else if ($ElecUsageCounterToonTotal >= $ElecUsageCounterDomoticz){
                $WriteValue = curl_init("http://$IPDomoticz/json.htm?type=command&param=udevice&idx=$idx&nvalue=0&svalue=$ElecUsageCounterLT;$ElecUsageCounterNT;$ElecProductionCounterLT;$ElecProductionCounterNT;$ElecUsageToon;$ElecProductionToon;");
                echo "Write new value \n";
                curl_exec($WriteValue);
        }
        else {
                echo "Domoticz value incorrect, do nothing \n";
        }
?>
